# 掃描

## 概述
掃描是一款用戶友好，使用Qt5進行開發的掃描軟件，提供熱插拔檢測、普通掃描、一鍵美化、智能糾偏和文字識別功能。
同時還包括了工具欄的裁切、旋轉、水印、水平翻轉等功能。

<br>

## 主界面

主界面功能簡潔，主要有掃描設置頁面和默認掃描儀連接狀態頁面。

<br>

![图 1 主界面-big](image/main.png)

<br>

## 檢測掃描儀設備

掃描軟件打開后，就會自動檢測通過USB直連或者設置網絡連接的掃描儀。

<br>
**注：掃描儀有對應的USB線，混用會導致不可知的錯誤，比如io錯誤。**

<br>

![图 2 检测扫描仪设备界面-big](image/detect-wait.png)

<br>

## 未檢測到掃描儀設備

當未檢測到多個掃描設備時，出現未檢測到掃描設備頁面。當掃描儀通過USB直連或者網絡連接到機器上時，可以通過點擊“連接掃描儀”按鈕進行再次連接。

<br>

![图 3 未检测到扫描仪设备-big](image/detect-fail.png)

<br>

## 已檢測到掃描儀設備

當檢測掃描設備結束時，已檢測到掃描設備，會出現如下初始化操作界面。此時，已選中默認掃描設備，並獲取了該默認掃描設備的參數显示在該界面。
發送郵件和另存為功能都不可用，當掃描出文檔，可變為可用狀態。

<br>

![图 4 已检测到扫描仪设备-big](image/main.png)

<br>

## 切換掃描設備

當檢測到多個掃描設備時，可以通過掃描設置頁面進行切換掃描設備。切換掃描設備時，會重新獲取掃描參數，進行更新掃描設置頁面中的參數。
如設備名、頁數、類型、顏色、分辨率和名稱等參數。

<br>

![图 5 切换扫描设备-big](image/switch-device.png)

<br>

## 掃描儀設置

掃描儀設置頁面可以進行以下參數設置：
- 1) 掃描設備
- 2) 掃描頁數
- 3) 多頁掃描的延時間隔
- 4) 掃描類型
- 5) 掃描顏色
- 6) 掃描分辨率
- 7) 掃描尺寸
- 8) 掃描個事
- 9) 掃描名稱
- 10) 掃描存儲目錄
- 11) 發送郵件
- 12) 另存爲

<br>

### 設置掃描頁數

在掃描設置頁面，可以設置掃描頁數，可設置為“單頁掃描”和“多頁掃描”兩種參數。
參數解釋：
“單頁掃描”參數：只能進行一次掃描，掃描結束后，不自動掃描。
“多頁掃描”參數：可以進行多次掃描，當第一次掃描結束后，可以根據設置的延時間隔進行下一次掃描，直到用戶自動結束掃描或遇到異常情況。
常見異常情況有：掃描儀中無可掃描文檔、掃描參數錯誤、掃描io錯誤等。

<br>

### 設置多頁掃描的延時間隔

設置多頁掃描的延時間隔參數代表多次掃描期間間隔的時間，可選參數有：3秒、5秒、7秒、10秒、15秒。

<br>

### 設置掃描類型

掃描類型代表按照不同的掃描儀類型進行掃描。該參數是根據選擇指定的掃描儀進行獲取的，可選參數有：平板式和饋紙式。
其中，饋紙式又可細分為ADF正面、ADF背面和ADF雙面三類。

針對不同的掃描儀有不同的掃描儀類型，如下：

1. 只支持平板式：Canon lide 210, Canon lide 300, Canon lide 400 等；
2. 支持饋紙式：hp OfficeJet_250_Mobile_series 等；
3. 平板式和饋紙式都支持：hp Color LaserJet Pro MFP M281fdw 等。

<br>

### 設置掃描分辨率

可以設置不同掃描儀分辨率，該參數也是根據指定掃描儀進行獲取，可選分辨率有： 75， 100， 150， 200， 300， 600， 1200， 2400。

**注：** 
越高分辨率，掃描時長越長，掃描出的圖片所佔內存越大，後期的圖像處理操作會有適當加載過慢現象，所以用戶選擇大於600的分辨率進行掃描時，會有對應提示。

<br>

### 設置掃描尺寸

從用戶選定的掃描儀設備獲取具體的掃描尺寸，可選參數為：A4， A5, A6。

不同掃描儀存在不同的掃描區域，比如**FUJITSU fi-7140**掃描儀是居中區域開始掃描。

**Canon lide 400**掃描儀是居左區域開始掃描。

### 設置掃描格式

可設置不同的掃描格式用於存儲掃描的文檔。可選參數為：jpg, png, pdf, bmp。

<br>

### 设置扫描至目录

設置掃描文檔的初始保存路徑，默認為家目錄下的“圖片/kylin-scanner-images”。

<br>

### 开始扫描

點擊“開始掃描”按鈕，可以設置不同的掃描參數進行掃描操作。<br>

### 发送邮件

掃描完成后，可以將掃描文檔通過系統已安裝的郵件客戶端進行發送郵件。

<br>

### 另存为

掃描完成或通過對掃描文檔編輯操作后，可以將掃描文檔另存為不同格式的文件。

## 工具欄
圖標及其功能:

| 圖標 | 功能說明 |
| :--------: | :---------: |
| ![](image/beauty.svg) | 一鍵美化 |
| ![](image/rectify.svg) |	智能糾偏 |
| ![](image/ocr.svg) | 文字識別 |
| ![](image/crop.svg) |	裁切 |
| ![](image/rotate.svg) | 旋轉 |
| ![](image/mirror.svg) | 鏡像翻轉 |
| ![](image/watermark.svg) | 添加水印 |
| ![](image/zoomout.svg) | 縮小 |
| ![](image/zoomin.svg) | 放大 |

<br>

### 一鍵美化

掃描完成后，可以對掃描文檔進行一鍵美化，包括飽和度、對比度和銳化等美化。

<br>

### 智能糾偏

掃描完成后，可以對掃描文檔進行智能糾偏，以便之後的文字識別操作。

<br>

### 文字識別

掃描完成后，可以對掃描文檔進行文字識別操作。在文字識別操作前，可以對文檔先進行智能糾偏，這樣高度糾偏的文檔識別效果更好。

<br>

### 裁切

掃描完成后，可以對文檔進行裁切，選取合適的文檔區域。

<br>

### 旋轉

掃描完成后，可以對文檔進行旋轉。<br>

### 鏡像翻轉

掃描完成后，可以對文檔進行鏡像翻轉。

<br>

### 添加水印

掃描完成后，可以對文檔進行添加水印操作。

<br>

